import React from 'react';
import Flag from 'react-country-flag';
import styled from 'styled-components';

function _objectDestructuringEmpty(obj) {
  if (obj == null) throw new TypeError("Cannot destructure undefined");
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

var dataSet = [['Afghanistan', 'AF', '93'], ['Albania', 'AL', '355'], ['Algeria', 'DZ', '213'], ['American Samoa', 'AS', '1 684'], ['Andorra', 'AD', '376'], ['Angola', 'AO', '244'], ['Anguilla', 'AI', '1'], ['Australian Antarctic', 'AQ', '672'], ['Antigua and Barbuda', 'AG', '1268'], ['Argentina', 'AR', '54'], ['Armenia', 'AM', '374'], ['Aruba', 'AW', '297'], ['Australia', 'AU', '61'], ['Austria', 'AT', '43'], ['Azerbaijan', 'AZ', '994'], ['Bahamas', 'BS', '1242'], ['Bahrain', 'BH', '973'], ['Bangladesh', 'BD', '880'], ['Barbados', 'BB', '1246'], ['Belarus', 'BY', '375'], ['Belgium', 'BE', '32'], ['Belize', 'BZ', '501'], ['Benin', 'BJ', '229'], ['Bermuda', 'BM', '1 441'], ['Bhutan', 'BT', '975'], ['Bolivia', 'BO', '591'], ['Bosnia and Herzegovina', 'BA', '387'], ['Botswana', 'BW', '267'], ['Bouvet Island', 'BV', '47'], ['Brazil', 'BR', '55'], ['British Indian Ocean Territory', 'IO', '246'], ['British Virgin Islands', 'VG', '1 284'], ['Brunei', 'BN', '673'], ['Bulgaria', 'BG', '359'], ['Burkina Faso', 'BF', '226'], ['Burundi', 'BI', '257'], ['Cambodia', 'KH', '855'], ['Cameroon', 'CM', '237'], ['Canada', 'CA', '1'], ['Cape Verde', 'CV', '238'], ['Caribbean Netherlands', 'BQ', '599'], ['Cayman Islands', 'KY', '1 345'], ['Central African Republic', 'CF', '236'], ['Chad', 'TD', '235'], ['Chile', 'CL', '56'], ['China', 'CN', '86'], ['Christmas Island', 'CX', '61'], ['Cocos Islands', 'CC', '61'], ['Colombia', 'CO', '57'], ['Comoros', 'KM', '269'], ['Cook Islands', 'CK', '682'], ['Costa Rica', 'CR', '506'], ['Croatia', 'HR', '385'], ['Cuba', 'CU', '53'], ['Curaçao', 'CW', '599'], ['Cyprus', 'CY', '357'], ['Czech Republic', 'CZ', '420'], ['Congo', 'CD', '243'], ['Denmark', 'DK', '45'], ['Djibouti', 'DJ', '253'], ['Dominica', 'DM', '1767'], ['Dominican Republic', 'DO', '1 809'], ['Ecuador', 'EC', '593'], ['Egypt', 'EG', '20'], ['El Salvador', 'SV', '503'], ['Equatorial Guinea', 'GQ', '240'], ['Eritrea', 'ER', '291'], ['Estonia', 'EE', '372'], ['Swaziland', 'SZ', '268'], ['Ethiopia', 'ET', '251'], ['Falkland Islands', 'FK', '500'], ['Faroe Islands', 'FO', '298'], ['Fiji', 'FJ', '679'], ['Finland', 'FI', '358'], ['France', 'FR', '33'], ['French Guiana', 'GF', '594'], ['French Polynesia', 'PF', '689'], ['French Southern and Antarctic Lands', 'TF', '262'], ['Gabon', 'GA', '241'], ['Gambia', 'GM', '220'], ['Georgia', 'GE', '995'], ['Germany', 'DE', '49'], ['Ghana', 'GH', '233'], ['Gibraltar', 'GI', '350'], ['Greece', 'GR', '30'], ['Greenland', 'GL', '299'], ['Grenada', 'GD', '1473'], ['Guadeloupe', 'GP', '590'], ['Guam', 'GU', '1671'], ['Guatemala', 'GT', '502'], ['Guernsey', 'GG', '44'], ['Guinea', 'GN', '224'], ['Guinea-Bissau', 'GW', '245'], ['Guyana', 'GY', '592'], ['Haiti', 'HT', '509'], ['Heard Island', 'HM', '672'], ['Honduras', 'HN', '504'], ['Hungary', 'HU', '36'], ['Iceland', 'IS', '354'], ['India', 'IN', '91'], ['Indonesia', 'ID', '62'], ['Iran', 'IR', '98'], ['Iraq', 'IQ', '964'], ['Ireland', 'IE', '353'], ['Isle of Man', 'IM', '44'], ['Israel', 'IL', '972'], ['Italy', 'IT', '39'], ['Côte d’Ivoire', 'CI', '225'], ['Jamaica', 'JM', '1876'], ['Japan', 'JP', '81'], ['Jersey', 'JE', '44'], ['Jordan', 'JO', '962'], ['Kazakhstan', 'KZ', '7'], ['Kenya', 'KE', '254'], ['Kosovo', 'XK', '383'], ['Kuwait', 'KW', '965'], ['Kyrgyzstan', 'KG', '996'], ['Laos', 'LA', '856'], ['Latvia', 'LV', '371'], ['Lebanon', 'LB', '961'], ['Lesotho', 'LS', '266'], ['Liberia', 'LR', '231'], ['Libya', 'LY', '218'], ['Liechtenstein', 'LI', '423'], ['Lithuania', 'LT', '370'], ['Luxembourg', 'LU', '352'], ['Macau', 'MO', '853'], ['Macedonia', 'MK', '389'], ['Madagascar', 'MG', '261'], ['Malawi', 'MW', '265'], ['Malaysia', 'MY', '60'], ['Maldives', 'MV', '960'], ['Mali', 'ML', '223'], ['Malta', 'MT', '356'], ['Marshall Islands', 'MH', '692'], ['Martinique', 'MQ', '596'], ['Mauritania', 'MR', '222'], ['Mauritius', 'MU', '230'], ['Mayotte', 'YT', '262'], ['Mexico', 'MX', '52'], ['Micronesia', 'FM', '691'], ['Moldova', 'MD', '373'], ['Monaco', 'MC', '377'], ['Mongolia', 'MN', '976'], ['Montenegro', 'ME', '382'], ['Montserrat', 'MS', '1 664'], ['Morocco', 'MA', '212'], ['Mozambique', 'MZ', '258'], ['Myanmar', 'MM', '95'], ['Namibia', 'NA', '264'], ['Nauru', 'NR', '674'], ['Nepal', 'NP', '977'], ['Netherlands', 'NL', '31'], ['New Caledonia', 'NC', '687'], ['New Zealand', 'NZ', '64'], ['Nicaragua', 'NI', '505'], ['Niger', 'NE', '227'], ['Nigeria', 'NG', '234'], ['Niue', 'NU', '683'], ['Norfolk Island', 'NF', '672'], ['North Korea', 'KP', '850'], ['Northern Mariana Islands', 'MP', '1 670'], ['Norway', 'NO', '47'], ['Oman', 'OM', '968'], ['Pakistan', 'PK', '92'], ['Palau', 'PW', '680'], ['Palestine', 'PS', '970'], ['Panama', 'PA', '507'], ['Papua New Guinea', 'PG', '675'], ['Paraguay', 'PY', '595'], ['Peru', 'PE', '51'], ['Philippines', 'PH', '63'], ['Pitcairn Islands', 'PN', '64'], ['Poland', 'PL', '48'], ['Portugal', 'PT', '351'], ['Puerto Rico', 'PR', '1'], ['Qatar', 'QA', '974'], ['Congo', 'CG', '242'], ['Romania', 'RO', '40'], ['Russia', 'RU', '7'], ['Rwanda', 'RW', '250'], ['Réunion', 'RE', '262'], ['Saint Barthélemy', 'BL', '590'], ['Saint Helena', 'SH', '290'], ['Saint Kitts and Nevis', 'KN', '1869'], ['Saint Lucia', 'LC', '1758'], ['Saint Martin', 'MF', '590'], ['Saint Pierre', 'PM', '508'], ['Saint Vincent and the Grenadines', 'VC', '1784'], ['Samoa', 'WS', '685'], ['San Marino', 'SM', '378'], ['Saudi Arabia', 'SA', '966'], ['Senegal', 'SN', '221'], ['Serbia', 'RS', '381'], ['Seychelles', 'SC', '248'], ['Sierra Leone', 'SL', '232'], ['Singapore', 'SG', '65'], ['Sint Maarten', 'SX', '1 721'], ['Slovakia', 'SK', '421'], ['Slovenia', 'SI', '386'], ['Solomon Islands', 'SB', '677'], ['Somalia', 'SO', '252'], ['South Africa', 'ZA', '27'], ['South Georgia', 'GS', '500'], ['South Korea', 'KR', '82'], ['South Sudan', 'SS', '211'], ['Spain', 'ES', '34'], ['Sri Lanka', 'LK', '94'], ['Sudan', 'SD', '249'], ['Suriname', 'SR', '597'], ['Svalbard', 'SJ', '47'], ['Sweden', 'SE', '46'], ['Switzerland', 'CH', '41'], ['Syria', 'SY', '963'], ['São Tomé and Príncipe', 'ST', '239'], ['Taiwan', 'TW', '886'], ['Tajikistan', 'TJ', '992'], ['Tanzania', 'TZ', '255'], ['Thailand', 'TH', '66'], ['Timor-Leste', 'TL', '670'], ['Togo', 'TG', '228'], ['Tokelau', 'TK', '690'], ['Tonga', 'TO', '676'], ['Trinidad and Tobago', 'TT', '1868'], ['Tunisia', 'TN', '216'], ['Turkey', 'TR', '90'], ['Turkmenistan', 'TM', '993'], ['Turks and Caicos Islands', 'TC', '1 649'], ['Tuvalu', 'TV', '688'], ['Uganda', 'UG', '256'], ['Ukraine', 'UA', '380'], ['United Arab Emirates', 'AE', '971'], ['United Kingdom', 'GB', '44'], ['United States', 'US', '1'], ['United States', 'UM', '1'], ['Virgin Islands ', 'VI', '1 340'], ['Uruguay', 'UY', '598'], ['Uzbekistan', 'UZ', '998'], ['Vanuatu', 'VU', '678'], ['Vatican City', 'VA', '39'], ['Venezuela', 'VE', '58'], ['Vietnam', 'VN', '84'], ['Wallis and Futuna', 'WF', '681'], ['Western Sahara', 'EH', '212'], ['Yemen', 'YE', '967'], ['Zambia', 'ZM', '260'], ['Zimbabwe', 'ZW', '263'], ['Kiribati', 'KI', '686'], ['Hong Kong', 'HK', '852'], ['Åland', 'AX', '358']];

var index = {
  __proto__: null,
  'default': dataSet
};

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8;
var PhoneSelector = function PhoneSelector(_ref) {
  _objectDestructuringEmpty(_ref);
};
var PhoneCodeSelector = function PhoneCodeSelector(_ref2) {
  var className = _ref2.className,
      width = _ref2.width,
      defaultValue = _ref2.defaultValue,
      disabled = _ref2.disabled,
      search = _ref2.search,
      onChange = _ref2.onChange;
  var ref = React.useRef(null);

  var _React$useState = React.useState({
    label: 'Select',
    value: ''
  }),
      selectedValue = _React$useState[0],
      setSelectedValue = _React$useState[1];

  var _React$useState2 = React.useState(false),
      show = _React$useState2[0],
      setShow = _React$useState2[1];

  var _React$useState3 = React.useState(null),
      searchValue = _React$useState3[0],
      setSearchValue = _React$useState3[1];

  var options = React.useMemo(function () {
    return dataSet.map(function (code) {
      return {
        label: code[0] + " +" + code[2],
        value: code[1]
      };
    });
  }, []);
  React.useEffect(function () {
    if (defaultValue && options) {
      options.forEach(function (option) {
        if (option.label.split('+')[1] === defaultValue.toLowerCase()) {
          setSelectedValue(option);
        }

        if (option.value.toLowerCase() === defaultValue.toLowerCase()) {
          setSelectedValue(option);
        }
      });
    }
  }, [defaultValue, options]);
  var handleClickOutside = React.useCallback(function (event) {
    event.stopPropagation();

    if (ref.current && !ref.current.contains(event.target)) {
      setShow(false);
      setSearchValue('');
    }
  }, []);
  var onChangeSearchValue = React.useCallback(function (e) {
    setSearchValue(e.target.value);
  }, []);
  React.useEffect(function () {
    document.addEventListener('click', handleClickOutside, false);
    return function () {
      document.removeEventListener('click', handleClickOutside, false);
    };
  }, []);
  return React.createElement(Container, {
    ref: ref,
    className: className
  }, React.createElement(Selected, {
    disabled: disabled,
    isDefault: selectedValue.value === '',
    width: width,
    onClick: function onClick() {
      return setShow(true);
    }
  }, selectedValue.value === '' ? React.createElement(SelectedText, {
    isEmpty: selectedValue.value === ''
  }, selectedValue.label) : React.createElement(SelectedText, null, React.createElement(React.Fragment, null, React.createElement(Flag, {
    countryCode: selectedValue.value
  }), "+", selectedValue.label.split('+')[1]))), show && React.createElement(SelectWrapper, {
    width: width
  }, search !== false && React.createElement(SearchWrapper, null, React.createElement(Input, {
    onFocus: function onFocus() {
      setShow(true);
    },
    type: "text",
    value: searchValue != null ? searchValue : '',
    onChange: onChangeSearchValue,
    placeholder: "Search for Phone Country"
  })), React.createElement(Options, null, options.filter(function (v) {
    return searchValue ? v.label.toLowerCase().includes(searchValue.toLowerCase()) : true;
  }).map(function (option, key) {
    return React.createElement(List, {
      hasSearch: search,
      key: key,
      onClick: function onClick() {
        setSelectedValue(option);
        onChange(option.label.split('+')[1]);
        setShow(false);
        setSearchValue('');
      }
    }, React.createElement(Flag, {
      countryCode: option.value
    }), option.label);
  }))));
};
var SelectedText = /*#__PURE__*/styled.div(_templateObject || (_templateObject = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  font-style: normal;\n  font-weight: normal;\n  font-size: 14px;\n  line-height: 19px;\n  margin-left: 20px;\n\n  color: ", ";\n"])), function (_ref3) {
  var isEmpty = _ref3.isEmpty,
      fontColor = _ref3.fontColor;
  return isEmpty ? '#BEC1CA' : fontColor;
});
var Selected = /*#__PURE__*/styled.div(_templateObject2 || (_templateObject2 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  position: relative;\n  width: ", ";\n  display: flex;\n  align-items: center;\n  height: 50px;\n  border-radius: 30px;\n  border: none;\n  text-align: start;\n  background-color: ", ";\n\n  color: ", ";\n\n  pointer-events: ", ";\n"])), function (_ref4) {
  var width = _ref4.width;
  return width ? width + "px" : '100%';
}, function (_ref5) {
  var backgroundColor = _ref5.backgroundColor;
  return backgroundColor ? backgroundColor : '#f9f9f9';
}, function (_ref6) {
  var isDefault = _ref6.isDefault;
  return isDefault ? '#BEC1CA' : '#0a112c';
}, function (_ref7) {
  var disabled = _ref7.disabled;
  return disabled ? 'none' : '';
});
var List = /*#__PURE__*/styled.div(_templateObject3 || (_templateObject3 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  padding: 15px 15px;\n  font-size: 16px;\n  color: ", ";\n\n  &:hover {\n    cursor: pointer;\n    background-color: ", ";\n  }\n\n  :first-child {\n    border-top-left-radius: ", "px;\n    border-top-right-radius: ", "px;\n  }\n\n  :last-child {\n    border-bottom-left-radius: 15px;\n    border-bottom-right-radius: 15px;\n  }\n"])), function (_ref8) {
  var hoverColor = _ref8.hoverColor;
  return hoverColor ? '#f9f9f9' : '#0a112c';
}, function (_ref9) {
  var hoverColor = _ref9.hoverColor;
  return hoverColor ? hoverColor : '#f9f9f9';
}, function (_ref10) {
  var hasSearch = _ref10.hasSearch;
  return hasSearch ? 0 : 15;
}, function (_ref11) {
  var hasSearch = _ref11.hasSearch;
  return hasSearch ? 0 : 15;
});
var Options = /*#__PURE__*/styled.div(_templateObject4 || (_templateObject4 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  max-height: 300px;\n  overflow-y: auto;\n"])));
var Input = /*#__PURE__*/styled.input(_templateObject5 || (_templateObject5 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  text-indent: 20%;\n  background-color: ", ";\n  width: 80%;\n  height: 40px;\n  border-radius: 21px;\n  margin: 20px 0;\n  border: none;\n  outline: none;\n\n  &::placeholder {\n    color: #d7d7d8;\n  }\n"])), function (_ref12) {
  var backgroundColor = _ref12.backgroundColor;
  return backgroundColor ? backgroundColor : '#f9f9f9';
});
var SearchWrapper = /*#__PURE__*/styled.div(_templateObject6 || (_templateObject6 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  position: relative;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n"])));
var SelectWrapper = /*#__PURE__*/styled.div(_templateObject7 || (_templateObject7 = /*#__PURE__*/_taggedTemplateLiteralLoose(["\n  z-index: 999;\n  position: absolute;\n  width: 30%;\n  max-width: 400px;\n  min-width: ", "px;\n  display: flex;\n  flex-direction: column;\n  width: ", ";\n  background-color: ", ";\n  border: ", ";\n  box-sizing: border-box;\n  box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.1);\n  border-radius: 20px;\n"])), function (_ref13) {
  var width = _ref13.width;
  return width ? width : 275;
}, function (_ref14) {
  var width = _ref14.width;
  return width ? width + "px" : '100%';
}, function (_ref15) {
  var backgroundColor = _ref15.backgroundColor;
  return backgroundColor ? backgroundColor : '#fffff';
}, function (_ref16) {
  var borderColor = _ref16.borderColor;
  return borderColor ? "1px solid " + borderColor : "1px solid #e6e8ed";
});
var Container = /*#__PURE__*/styled.div(_templateObject8 || (_templateObject8 = /*#__PURE__*/_taggedTemplateLiteralLoose([""])));

export { PhoneCodeSelector, PhoneSelector, index as data };
//# sourceMappingURL=react-phone-code-selector.esm.js.map
